//Soubor: 17D_Mother.jsh
//################################## Příliš žluťoučký kůň úpěl ďábelské ódy
//#########################################################################

/*******************************************************************************
 * Instance třídy {@code Mother} představují matky.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
class Mother
{
    static { println("#####  Zavádím třídu Mother  #####"); }
    { println("+++++  Inicializuji instanci třídy Mother  +++++"); }

    /** Počet doposud vytvořených instancí.*/
    protected static int created = 0;

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */
    protected final String ID = "M" +  ++created;


    /***************************************************************************
     * Konstruktor instance matky.
     * Rodičovským podobjektem je virtuální instance třídy {@link Object}.
     */
    public Mother()
    {
//        super();
        constructorReport(this, Mother.class);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kteří potřebují něco provést
     * před zavoláním rodičovského konstruktoru.
     *
     * @param s Nepoužitý parametr
     */
    protected Mother(String s)
    {
        this();
    }

    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Mother_" + ID + "(Object)";
    }

    { println("-----  Konec úvodní fáze inicializace Mother  -----"); }
    static { println("-----  Třída Mother zavedena  -----"); }
}



/**Výpis
**************************************************************************/
//#########################################################################
//save -history 17S_d1_Mother.jsh
