/* Historie s oddělovacími komentáři: 26C_Records.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 26.0: Inicializace
********************************************************************/
/set start Start_26.jsh
/reset
/********************************************************************


/*
** Výpis 26.1: Definice záznamu o trojúhelníku definovaném podle věty SSS
**             (Side-Side-Side) a přehled jeho metod
********************************************************************/
record TriangleSSS(double a, double b, double c) {}
new TriangleSSS(1, 2, 3);
printFCM(TriangleSSS.class);
/********************************************************************


/*
** Výpis 26.2: Definice interfejsu charakterizujícího záznamy
**             o trojúhelnících definovaných podle věty SSS
**             a záznamu implementujícím tento interfejs
********************************************************************/
interface ITriangleSSS
{
    double a();
    double b();
    double c();
}
record TriangleSSSi(double a, double b, double c)
implements ITriangleSSS
{}
ITriangleSSS it = new TriangleSSSi(11, 22, 33);
/********************************************************************


/*
** Výpis 26.3: Definice záznamu s explicitní definicí kanonického konstruktoru
********************************************************************/
record TriangleSSSe(double a, double b, double c)
implements ITriangleSSS
{
    public TriangleSSSe
    {
        println ("Vytvořen záznam o trojúhelníku " + this);
    }
}
printFCM(TriangleSSSe.class);
it = new TriangleSSSe(10, 20, 30);
/********************************************************************


/*
** Výpis 26.4: Upravená definice záznamu s explicitní definicí kanonického konstruktoru
********************************************************************/
record TriangleSSSec(double a, double b, double c)
implements ITriangleSSS
{
    public TriangleSSSec
    {
        this.a = a;
//        this.b = b;
        this.c = c;
        println ("Vytvořen záznam o trojúhelníku " + this);
    }
}
it = new TriangleSSSec(101, 202, 303);
/********************************************************************


/*
** Výpis 26.5: Uvedeme-li parametry konstruktoru, musíme je inicializovat
********************************************************************/
record TriangleSSSecw(double a, double b, double c)
{
    public TriangleSSSecw(double a, double b, double c)
    {
        println ("Vytvořen záznam o trojúhelníku " + this);
    }
}
/********************************************************************


/*
** Výpis 26.6: První část definice záznamu RightTriangleSSS obsahující
**             definice statických atributů a konstruktorů
********************************************************************/
/*Definice:
j:\62_PGM\JSH\26D_RightTriangleSSS.jsh
1. část
*/
/********************************************************************


/*
** Výpis 26.7: Prověrka funkcionality konstruktorů záznamů typu RightTriangleSSS
********************************************************************/
/open 26D_RightTriangleSSS.jsh
new RightTriangleSSS(2, 3, 4, 5);
var rt34 = new RightTriangleSSS(3, 4);
var rt11 = new RightTriangleSSS(Math.sqrt(2));
/********************************************************************


/*
** Výpis 26.8: Druhá část definice záznamu RightTriangleSSS obsahující
**             definice přebitých a nových instančních metod
********************************************************************/
/*Definice:
j:\62_PGM\JSH\26D_RightTriangleSSS.jsh
2. část
*/
/********************************************************************


/*
** Výpis 26.9: Prověrka funkcionality definovaných instančních metod
********************************************************************/
rt11.alphaBeta();
rt34.equals(rt11)
it = new RightTriangleSSS(3, 4)
rt34.equals(it);  it.equals(rt34)
rt34.hashCode() - it.hashCode()
it = new TriangleSSSi(3, 4, 5)
rt34.equals(it);  it.equals(rt34)
rt34.hashCode() - it.hashCode()
/********************************************************************


/*
** Rekapitulace a závěrečné uložení
********************************************************************/
/imports
/vars
/methods
/types
/save -history 26H_Records.jsh
