/* Historie s oddělovacími komentáři: 27C_Lambdas.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 27.0: Inicializace
********************************************************************/
/set start Start_17.jsh
/reset
/********************************************************************


/*
** Výpis 27.1: Funkční interfejsy v balíčku java.util.function
********************************************************************/
/*
Přehledová tabulka
*/
/********************************************************************


/*
** Výpis 27.2: Důležité funkční interfejsy z jiných balíčků
********************************************************************/
/*
Přehledová tabulka
*/
/********************************************************************


/*
** Výpis 27.3: Demonstrace použití lambda výrazu na aplikaci vybrané operace
********************************************************************/
IntBinaryOperator ibo;      int result;
ibo = (a, b) -> a + b;      result = ibo.applyAsInt(5, 6);
ibo = (a, b) -> a - b;      result = ibo.applyAsInt(5, 6);

/********************************************************************


/*
** Výpis 27.4: Rozdílné vnímání signatury metody při kvalifikaci
 *             třídou a instancí
********************************************************************/
ToIntFunction<String> cmpI = "První"::compareTo;
int inst = cmpI.applyAsInt("Druhý");
ToIntBiFunction<String,String> cmpC = String::compareTo;
int cls = cmpC.applyAsInt("První", "Druhý");

/********************************************************************


/*
** Výpis 27.5: Definice testovacích metod světel s nastavitelným tvarem
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c27_lambda\LightTest.java
Metody: changeShape(?), testBulbShape()
*/
/********************************************************************


/*
** Výpis 27.6: Definice třídy JumpingButton
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c27_lambda\JumpingButton.java
*/
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 27H_Lambdas.jsh
