/* Historie s oddělovacími komentáři: ABD_Swing.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis X.0: Inicializace
********************************************************************/
import java.awt.*
import java.awt.event.*;
import javax.swing.*;
/********************************************************************


/*
** Výpis X.0: Projekt
********************************************************************/
int X = 0, Y = 1, BAD = Integer.MAX_VALUE;
JFrame  frame;
JTextField[] jtf = {null, null};
int [] coordinates = {0, 0};
void axisPanel(Box box, int axis)
{
    Box        panel = new Box(BoxLayout.X_AXIS);
    JTextField input = jtf[axis] = new JTextField(""+coordinates[axis]);
    panel.add(new Label("Souřadnice " + (char)('X' + axis) + ": "));
    panel.add(input);
    input.addFocusListener(new FocusAdapter()
    {
        @Override public void focusLost(FocusEvent e) {
            int value;
            try {
                value = Integer.parseInt(input.getText().trim());
            } catch(NumberFormatException nfe) {
                JOptionPane.showMessageDialog(null,
                    "Špatně zadané číslo\nZkuste je zadat znovu");
                value = BAD;
            }
            coordinates[axis] = value;
        }
    });
    box.add(panel);
}
void addButtonPanel()
{
    JPanel  panel  = new JPanel();
    frame.add(panel, BorderLayout.SOUTH);

    JButton getButton = new JButton("Načti souřadnice");
    panel.add(getButton);
    getButton.addActionListener(e -> {
        Point p = frame.getLocation();
        coordinates[X] = p.x;    jtf[X].setText(""+p.x);
        coordinates[Y] = p.y;    jtf[Y].setText(""+p.y);
    });

    JButton setButton = new JButton("Nastav souřadnice");
    panel.add(setButton);
    setButton.addActionListener(e -> {
        if ((coordinates[X] != BAD)  &&  (coordinates[Y] != BAD)) {
            frame.setLocation(coordinates[X], coordinates[Y]);
        }
    });
}
JFrame swingDemo()
{
    frame = new JFrame("Demo tvorby GUI");
    Box box = new Box(BoxLayout.Y_AXIS);  //Panel panelů vstupních polí
    frame.add(box);
    axisPanel(box, X);
    axisPanel(box, Y);
    addButtonPanel();
    frame.addComponentListener(new ComponentAdapter()
    {
        @Override public void componentMoved(ComponentEvent e)
        {
            Point p = frame.getLocation();
            coordinates[X] = p.x;       jtf[X].setText(""+p.x);
            coordinates[Y] = p.y;       jtf[Y].setText(""+p.y);
        }
    });
    frame.pack();
    frame.setAlwaysOnTop(true);
    frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    frame.setVisible(true);
    return frame;
}
var JFS = swingDemo();
/********************************************************************


/*
** Výpis X.0: Knihovna
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\lib20s\geom\Direction8.java
*/
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 00H_Template.jsh
