/* Historie s oddělovacími komentáři: 05C_Methods.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 5.1: Definice a následné zavolání metody doubleText()
********************************************************************/
String text = "«text»";
void doubleText()
{
    text = text + text;
}
doubleText();
text
/********************************************************************


/*
** Výpis 5.2: Definice a použití metody println(Object)
********************************************************************/
void println(Object object)
{
    System.out.println(object);
}
println(text);
println("Copyright: \u00A9\nPlusMínus: \u00b1");
/********************************************************************


/*
** Výpis 5.3: Definice a použití metody println(Object)
********************************************************************/
void printPerson(String firstName, String secondName, String surname,
                 int birthYear)
{
    println(  "Křestní:  " + firstName
          + "\nDruhé:    " + secondName
          + "\nPříjmení: " + surname
          + "\nBylo by/Je mu/jí " + (2020 - birthYear) + " let"
           );
}
printPerson("Josef", "Václav", "Sládek", 1840);
printPerson("Karel", "",       "Čapek",  1890);
/********************************************************************


/*
** Výpis 5.4: Definice a použití metody hypotenuse(double, double)
********************************************************************/
double hypotenuse(double a, double b)
{
    return Math.sqrt(a * a  +  b * b);
}
hypotenuse(3, 4);  //Má vyjít 5, protože 3*3 + 4*4 = 25
hypotenuse(5, 12);  //Má vyjít 13, protože 5*5 + 12*12 = 25+144 = 169
hypotenuse(1, 1);  //Má vyjít cca 1.414 = odmocnina ze dvou
/********************************************************************


/*
** Výpis 5.5: Použití přetížených verzí metod
********************************************************************/
Math.max(1, 3);  //Oba typu int => použije se verze int
Math.max(1L, 3);  //První typu long, druhý int => použije se long
Math.max(1, 3.0);  //První int, druhý double => použije se double
void xxx(int i) { println("Verze int s hodnotou " + i); }
void xxx(double d) { println("Verze double s hodnotou " + d); }
xxx(1);     //Argument typu int -> použije se verze int
xxx(2L);    //Argument typu long -> použije se verze double
/********************************************************************


/*
** Výpis 5.6: Lokální proměnné a jejich použití
********************************************************************/
void local() //Chybně zadané použití proměnné před přiřazením hodnoty
{
    String local;
    println(local);
}
void local() //Redefinice, v níž je proměnné nejprve přiřazena
{            //hodnota, a teprve poté je proměnná použita
    String local;
    println("Budeme přiřazovat");
    local = "Hodnota přiřazena";
    println(local);
}
local();    //Volání právě definované metody
local = "Přiřazení";  //Pro okolní program proměnná local neexistuje
/********************************************************************


/*
** Výpis 5.7: Příklad
********************************************************************/
/** Do závodní jídelny koupili 15 kg ořechů a o 29 kg více švestek.
 *  Jablek koupili 6krát více než švestek.
 *  Kolik kilogramů jablek koupili? */
void jídelna()
{
    int ořechů  = 15;
    int švestek = ořechů + 29;
    int jablek  = švestek * 6;
    println("Závodní jídelna nakoupila " + jablek + " kg jablek");
}
jídelna();
double hypotenuse(double a, double b)
{
    double result = Math.sqrt(a * a  +  b * b);
    return result;
}
/********************************************************************


/*
** Výpis 5.8: Metody s proměnným počtem parametrů
********************************************************************/
void variant(String title, int... params)
{
    int count = params.length;
    println(count + " volitelných argumentů pro " + title);
}
variant("Nic");
variant("Pět", 1, 2, 3, 4, 5);
/********************************************************************


/*
** Výpis 5.9: Výpis aktivních metod příkazem /methods
********************************************************************/
/methods
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 05H_Methods.jsh
