/* Historie s oddělovacími komentáři: 17C_Subclassing.jsh
############################## Příliš žluťoučký kůň úpěl ďábelské ódy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Výpis 17.0: Inicializace
********************************************************************/
/set start Start_17.jsh
/reset
/********************************************************************


/*
** Výpis 17.1: První definice třídy Square
********************************************************************/
class Square extends Rectangle {}
void inform(Object o, String message)
{
    String text = message + "\n   " + o;
    System.out.println(text);
    IO.inform(text);
}
void testSquare(Square sq)
{
                                 inform(sq,"Testovaný objekt");
    sq.moveRight(100);           inform(sq,"Po posunu o 100 bodů vpravo");
    sq.setSize(200);             inform(sq,"Po změně rozměru na 200");
    sq.setPosition(50, 50);      inform(sq,"Po posunu na pozici [50;50]");
    sq.setColor(NamedColor.GOLD);inform(sq,"Po nastavení zlaté barvy");
}
testSquare(new Square());
/********************************************************************


/*
** Výpis 17.2: Definice třídy Square s upravenou verzí konstruktoru
********************************************************************/
class Square extends Rectangle
{
    Square()
    {
        super();
        setSize(Canvas.getStep());
    }
}
testSquare(new Square());
/********************************************************************


/*
** Výpis 17.3: Definice třídy Square se čtyřmi konstruktory
********************************************************************/
class Square extends Rectangle
{
    Square()
    {
        this(0, 0);
    }

    Square(int x, int y)
    {
        this(x, y, Canvas.getStep());
    }

    Square(int x, int y, int size)
    {
        super(x, y, size, size);
//    //Tělo by bylo možno stejně dobře definovat příkazem
//    this(x, y, size, DEFAULT_COLOR);
    }

    Square(int x, int y, int size, NamedColor color)
    {
        super(x, y, size, size, color);
    }
}
{ testSquare(new Square());
  testSquare(new Square(50, 100));
  testSquare(new Square(50,  50, 150));
  testSquare(new Square(25,  25,  25, NamedColor.GRAY));
}
/********************************************************************


/*
** Výpis 17.4: Definice třídy Granddaughter
********************************************************************/
/*Definice z NetBeans:
14-28_Projects\src\eu\pedu\b62_j14\c17_inheritance\Granddaughter.java
/********************************************************************


/*
** Výpis 17.5: Definice metody constructorReport(Object,Class)
 *             ve třídě Reports
********************************************************************/
/*Definice z NetBeans:
14-28_Projects\src\eu\pedu\b62_j14\c17_inheritance\Reports.java
/********************************************************************


/*
** Výpis 17.6: Vytváření instancí tříd v dědické hierarchii
********************************************************************/
/open 17D_Reports.jsh
/open 17D_Mother.jsh
/open 17D_Daughter.jsh
/open 17D_Granddaughter.jsh
{
    new Granddaughter();
    new Daughter();
    new Mother();
}
/********************************************************************


/*
** Závěrečné uložení
********************************************************************/
/save -history 17H_Subclassing.jsh
